'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _keyvLruFiles = require('keyv-lru-files');

var _keyvLruFiles2 = _interopRequireDefault(_keyvLruFiles);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cache = function () {
    function Cache(options) {
        _classCallCheck(this, Cache);

        this.handle = new _keyvLruFiles2.default(options);
        this.handle.opts.dir = _path2.default.format({
            root: options.root,
            name: options.dir
        });
    }

    _createClass(Cache, [{
        key: 'has',
        value: function has(id) {
            return this.handle.has(id);
        }
    }, {
        key: 'get',
        value: function get(id) {
            return this.handle.stream(id);
        }
    }, {
        key: 'clear',
        value: function clear() {
            return this.handle.clear();
        }
    }, {
        key: 'del',
        value: function del(id) {
            return this.handle.delete(id);
        }
    }, {
        key: 'set',
        value: function set(id, stream) {
            var _this = this;

            return new Promise(function (resolve, reject) {
                return (0, _mkdirp2.default)(_this.handle.opts.dir, function (err) {
                    if (err) return reject(err);
                    return resolve();
                });
            }).then(function () {
                return _this.handle.set(id, stream);
            });
        }
    }]);

    return Cache;
}();

exports.default = Cache;