'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useFile = useFile;
exports.isFile = isFile;
exports.default = File;

var _fs = require('fs');

var _path = require('path');

var _constants = require('./constants');

function check(name) {
    try {
        return require.resolve(name);
    } catch (e) {
        return null;
    }
}
function useFile(ezs, name) {
    var plugName1 = check('ezs-'.concat(name.replace(/^ezs-/, '')));
    var plugName2 = ezs.getPath().map(function (dir) {
        return (0, _path.resolve)(dir, name);
    }).map(function (fil) {
        return check(fil);
    }).filter(function (fun) {
        return fun !== null;
    }).shift();
    var plugName3 = check(name);
    if (plugName1) {
        (0, _constants.DEBUG)('Using \'' + name + '\' from ' + plugName1);
        return plugName1;
    }
    if (plugName2) {
        (0, _constants.DEBUG)('Using \'' + name + '\' from ' + plugName2);
        return plugName2;
    }
    if (plugName3) {
        (0, _constants.DEBUG)('Using \'' + name + '\' from ' + plugName1);
        return plugName3;
    }
    (0, _constants.DEBUG)('Unable to find \'' + name + '\' from ' + plugName1);
    (0, _constants.DEBUG)('Unable to find \'' + name + '\' from ' + plugName2);
    (0, _constants.DEBUG)('Unable to find \'' + name + '\' from ' + plugName3);
    return false;
}

function isFile(file) {
    try {
        return (0, _fs.statSync)(file).isFile();
    } catch (e) {
        return false;
    }
}

function File(ezs, name) {
    try {
        var filename = useFile(ezs, name);
        if (!filename) {
            return false;
        }
        if (!isFile(filename)) {
            return false;
        }
        ezs.addPath((0, _path.dirname)(filename));
        return (0, _fs.readFileSync)(filename, 'utf8');
    } catch (e) {
        return false;
    }
}