'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = Script;

var _expression = require('./expression');

var _expression2 = _interopRequireDefault(_expression);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regex = {
    section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
    param: /^\s*([\w.\-_]+)\s*[=: ]\s*(.*?)\s*$/,
    comment: /^\s*[;#].*$/
};

var parseOpts = function parseOpts(obj) {
    var res = {};
    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        Object.keys(obj).forEach(function (key) {
            var val = obj[key].length === 1 ? obj[key][0] : obj[key];
            res[key] = new _expression2.default(val);
        });
    }
    return res;
};

function Script(commands) {
    if (!commands) {
        return [];
    }
    var lines = commands.split(/\r\n|\r|\n/);
    var result = [];
    lines.forEach(function (line) {
        if (!regex.comment.test(line)) {
            if (regex.param.test(line)) {
                var match = line.match(regex.param);
                var paramName = match[1];
                var paramValue = match[2];
                var section = result.length > 0 ? result[result.length - 1] : null;
                if (section) {
                    if (!section.args[paramName]) {
                        result[result.length - 1].args[paramName] = [];
                    }
                    result[result.length - 1].args[paramName].push(paramValue);
                }
            } else if (regex.section.test(line)) {
                var matches0 = line.match(regex.section);
                var matches1 = matches0[1].match(/(\w+)\?(\w+)/);
                var mode = _constants.M_NORMAL;
                var name = 'debug';
                var test = '';
                if (Array.isArray(matches1)) {
                    var _matches = _slicedToArray(matches1, 3);

                    name = _matches[1];
                    mode = _matches[2];
                } else {
                    mode = _constants.M_NORMAL;

                    var _matches2 = _slicedToArray(matches0, 2);

                    name = _matches2[1];
                }
                var newSection = {
                    mode: mode,
                    name: name,
                    test: test,
                    args: {}
                };
                result.push(newSection);
            }
        }
    });
    var cmd = result.map(function (command) {
        return _extends({}, command, {
            args: parseOpts(command.args)
        });
    });
    return cmd;
}