'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require('fs');

var _file = require('../file');

var serverPipeline = function serverPipeline(ezs) {
    return function (request, response) {
        var pathname = request.url.pathname;

        var filePath = ezs.fileToServe(pathname);
        if (!(0, _file.isFile)(filePath)) {
            response.writeHead(404);
            response.end();
            return false;
        }
        response.writeHead(200, {
            'Content-Type': 'text/plain'
        });
        (0, _fs.createReadStream)(filePath).pipe(response);
        return true;
    };
};

exports.default = serverPipeline;