'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = Shell;

var _autocast = require('autocast');

var _autocast2 = _interopRequireDefault(_autocast);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _notevil = require('notevil');

var _notevil2 = _interopRequireDefault(_notevil);

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parse = function parse(chunk, environment) {
    return function (expression) {
        var js = [];
        js.push('_.chain(self).');
        js.push(expression.replace(/([)]\s*->\s*)/g, ').'));
        js.push('.value();');
        var code = js.join('');
        var data = (typeof chunk === 'undefined' ? 'undefined' : _typeof(chunk)) === 'object' ? _lodash2.default.omitBy(chunk, _lodash2.default.isFunction) : chunk;
        _lodash2.default.mixin(_extends({}, _mixins2.default, {
            env: function env(i, p, d) {
                return _lodash2.default.get(environment, p, d);
            }
        }));
        var result = (0, _notevil2.default)(code, {
            _: _lodash2.default,
            self: data
        });
        return result;
    };
};

var analyse = function analyse(chunk, environment) {
    return function (expression) {
        if (Array.isArray(expression)) {
            return expression.map(analyse(chunk, environment));
        }
        if (!expression || typeof expression !== 'string') {
            return expression;
        }
        if (expression.match(/^[a-zA-Z][a-zA-Z0-9]*[(]/)) {
            return parse(chunk, environment)(expression);
        }
        return (0, _autocast2.default)(expression);
    };
};

function Shell(expression, chunk, environment) {
    if (Array.isArray(expression)) {
        return expression.map(function (item) {
            if (typeof expression !== 'function') {
                return item;
            }
            return item(analyse(chunk, environment));
        });
    }
    if (!expression || !expression.through) {
        return expression;
    }
    return expression.through(analyse(chunk, environment));
}