'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = assign;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Take `Object` and add new field
 *
 * @param {String} [path] path of the new field
 * @param {String} [value] value of the new field
 * @returns {Object}
 */
function assign(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    var test = this.getParam('test', true);
    if (!test) {
        return feed.send(data);
    }
    var path = this.getParam('path', []);
    var value = this.getParam('value');
    var vals = Array.isArray(path) && !Array.isArray(value) ? [value] : value;
    if (Array.isArray(path)) {
        var values = _lodash2.default.take(vals, path.length);
        var assets = _lodash2.default.zipObject(path, values);
        Object.keys(assets).forEach(function (key) {
            _lodash2.default.set(data, key, assets[key]);
        });
    } else {
        _lodash2.default.set(data, path, vals);
    }
    return feed.send(data);
}