'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = dump;
/**
 * Take all `Object` and genereta a json array
 *
 * @param {String} [indent=false] indent JSON
 * @returns {String}
 */
function dump(data, feed) {
    var indent = this.getParam('indent', false);
    var separator = indent ? ',\n' : ',';
    var spaces = indent ? '    ' : null;
    var openWith = '[';
    var closeWith = ']';
    var output = '';
    if (this.isFirst()) {
        output = openWith;
    } else {
        output = separator;
    }
    if (!this.isLast()) {
        feed.write(output.concat(JSON.stringify(data, null, spaces)));
    } else if (this.isLast() && this.getIndex() > 0) {
        feed.write(closeWith);
        feed.close();
    } else {
        feed.write(openWith + closeWith);
        feed.close();
    }
    return feed.end();
}