'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = group;

var _settings = require('../settings');

var _settings2 = _interopRequireDefault(_settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Take all `chunk`, and throw array of chunks
 *
 * @param {Number} [size] Size of each partition
 * @returns {String}
 */
function group(data, feed) {
    var size = Number(this.getParam('size')) || _settings2.default.nShards;

    if (this.isFirst()) {
        this.buffer = [];
    }
    if (this.isLast()) {
        if (this.buffer && this.buffer.length > 0) {
            feed.write(Array.from(this.buffer));
        }
        return feed.close();
    }
    this.buffer.push(data);
    if (this.buffer.length >= size) {
        var buf = Array.from(this.buffer);
        this.buffer = [];
        return feed.send(buf);
    }
    return feed.end();
}