'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = shuffle;
function shuf(input) {
    var a = input.split('');
    var n = a.length;

    for (var i = n - 1; i > 0; i -= 1) {
        var j = Math.floor(Math.random() * (i + 1));
        var tmp = a[i];
        a[i] = a[j];
        a[j] = tmp;
    }
    return a.join('');
}

/**
 * Take `Object`, shuffle data of the whole object or only some fields specified by path
 *
 * @param {String} [path] path of field to shuffle
 * @returns {Object}
 */
function shuffle(data, feed) {
    if (this.isLast()) {
        return feed.send(data);
    }
    var path = this.getParam('path', []);
    var keys = Array.isArray(path) ? path : [path];
    var output = {};

    if (keys.length === 0) {
        Object.keys(data).forEach(function (key) {
            output[key] = shuf(data[key]);
        });
    } else {
        Object.keys(data).forEach(function (key) {
            if (keys.indexOf(key) === -1) {
                output[key] = data[key];
            } else {
                output[key] = shuf(data[key]);
            }
        });
    }
    return feed.send(output);
}