'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = unpack;
/**
 * Take `String` and throw `Object` builded by JSON.parse on each line
 *
 * @returns {String}
 */
var eol = '\n';
function unpack(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    this.remainder = this.remainder || '';

    var lines = void 0;
    if (Buffer.isBuffer(data)) {
        lines = data.toString().split(eol);
    } else if (typeof data === 'string') {
        lines = data.split(eol);
    } else {
        lines = ['', ''];
    }
    lines.unshift(this.remainder + lines.shift());
    this.remainder = lines.pop();
    lines.forEach(function (line) {
        feed.write(JSON.parse(line));
    });
    return feed.end();
}